--AH:ScriptId=535c607c-0a69-4399-a4ae-ad01e440ee9d;2827
ALTER TABLE [Packages]
	ADD [Major_Number] INT,
	    [Minor_Number] INT,
		[Patch_Number] INT,
		[Build_Number] INT,
		[Prerelease_Text] NVARCHAR(40)
GO

ALTER TABLE [Packages]
	ALTER COLUMN [TargetFrameworks_Text] VARCHAR(255) NULL

UPDATE P
   SET P.[Major_Number] = V.[Major],
       P.[Minor_Number] = V.[Minor],
	   P.[Patch_Number] = V.[Patch],
	   P.[Build_Number] = V.[Build],
	   P.[Prerelease_Text] = V.[Prerelease],
	   P.[TargetFrameworks_Text] = NULLIF(P.[TargetFrameworks_Text], '')
  FROM [Packages] P
       CROSS APPLY dbo.ParseNuGetVersion([Version_Text]) V

DELETE [Packages]
 WHERE [Major_Number] IS NULL

ALTER TABLE [Packages]
	ALTER COLUMN [Major_Number] INT NOT NULL

ALTER TABLE [Symbols]
	DROP CONSTRAINT [FK__Symbols__Packages]

ALTER TABLE [Packages]
	DROP CONSTRAINT [PK__Packages]

ALTER TABLE [Packages]
	DROP COLUMN [Version_Text]

ALTER TABLE [Packages]
	ADD [Prerelease_Indicator] AS CAST(CASE WHEN [Prerelease_Text] IS NOT NULL THEN 'Y' ELSE 'N' END AS CHAR(1)) PERSISTED NOT NULL

ALTER TABLE [Packages]
	ADD [Version_Text] AS CAST((CAST([Major_Number] AS NVARCHAR(10))
	                    + (CASE WHEN [Minor_Number] IS NOT NULL THEN '.' + CAST([Minor_Number] AS NVARCHAR(10)) ELSE '' END)
						+ (CASE WHEN [Patch_Number] IS NOT NULL THEN '.' + CAST([Patch_Number] AS NVARCHAR(10)) ELSE '' END)
						+ (CASE WHEN [Build_Number] IS NOT NULL THEN '.' + CAST([Build_Number] AS NVARCHAR(10)) ELSE '' END)
						+ (CASE WHEN [Prerelease_Text] IS NOT NULL THEN '-' + [Prerelease_Text] ELSE '' END)) AS NVARCHAR(50))
						  PERSISTED NOT NULL

CREATE CLUSTERED INDEX [IX__Packages__Clustered]
	ON [Packages] ([Feed_Id], [Package_Id], [Major_Number] DESC, [Minor_Number] DESC, [Patch_Number] DESC, [Build_Number] DESC, [Prerelease_Indicator], [Prerelease_Text] DESC)

ALTER TABLE [Packages]
	ADD CONSTRAINT [PK__Packages]
		PRIMARY KEY NONCLUSTERED ([Feed_Id], [Package_Id], [Version_Text])

UPDATE S
   SET S.[Package_Version_Text] = CAST((CAST(V.[Major] AS NVARCHAR(10))
	                    + (CASE WHEN V.[Minor] IS NOT NULL THEN '.' + CAST(V.[Minor] AS NVARCHAR(10)) ELSE '' END)
						+ (CASE WHEN V.[Patch] IS NOT NULL THEN '.' + CAST(V.[Patch] AS NVARCHAR(10)) ELSE '' END)
						+ (CASE WHEN V.[Build] IS NOT NULL THEN '.' + CAST(V.[Build] AS NVARCHAR(10)) ELSE '' END)
						+ (CASE WHEN V.[Prerelease] IS NOT NULL THEN '-' + V.[Prerelease] ELSE '' END)) AS NVARCHAR(50))
  FROM [Symbols] S
 CROSS APPLY dbo.ParseNuGetVersion(S.[Package_Version_Text]) V

ALTER TABLE [Symbols]
	ADD CONSTRAINT [FK__Symbols__Packages]
		FOREIGN KEY ([Feed_Id], [Package_Id], [Package_Version_Text])
		REFERENCES [Packages] ([Feed_Id], [Package_Id], [Version_Text])

ALTER TABLE [Packages]
	ADD CONSTRAINT [CK__Packages__Major_Number]
		CHECK ([Major_Number] >= 0)

ALTER TABLE [Packages]
	ADD CONSTRAINT [CK__Packages__Minor_Number]
		CHECK ([Minor_Number] IS NULL OR [Minor_Number] >= 0)

ALTER TABLE [Packages]
	ADD CONSTRAINT [CK__Packages__Patch_Number]
		CHECK (([Patch_Number] IS NULL OR [Minor_Number] IS NOT NULL)
		  AND ([Patch_Number] IS NULL OR [Patch_Number] >= 0))

ALTER TABLE [Packages]
	ADD CONSTRAINT [CK__Packages__Build_Number]
		CHECK (([Build_Number] IS NULL OR [Patch_Number] IS NOT NULL)
		  AND ([Build_Number] IS NULL OR [Build_Number] >= 0))

ALTER TABLE [Packages]
	ADD CONSTRAINT [CK__Packages__Prerelease_Text]
		CHECK ([Prerelease_Text] <> '')

ALTER TABLE [Packages]
	DROP COLUMN [NuspecxFile_Bytes]