EXEC [__AddStoredProcInfo]
    /* StoredProc_Name         */ 'Vulnerabilities_GetVulnerabilitiesForPackage',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'DataTable',
    /* DataTableNames_Csv      */ 'Vulnerabilities_Extended',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Gets the vulnerabilties for a package.'
GO

IF OBJECT_ID('[Vulnerabilities_GetVulnerabilitiesForPackage]') IS NOT NULL DROP PROCEDURE [Vulnerabilities_GetVulnerabilitiesForPackage]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Vulnerabilities_GetVulnerabilitiesForPackage]
(
	@Feed_Id INT,
	@Package_Name VARCHAR(200)
)
AS
BEGIN

SET NOCOUNT ON

	SELECT V.*
	  FROM [Vulnerabilities_Extended] V
	       LEFT JOIN [FeedVulnerabilitySources] FVS
		           ON V.[VulnerabilitySource_Id] = FVS.[VulnerabilitySource_Id]
	       INNER JOIN [Feeds] F
		           ON F.[Feed_Id] = FVS.[Feed_Id] OR F.[Feed_Id] = V.[Feed_Id]
	 WHERE F.[Feed_Id] = @Feed_Id
	   AND V.[Package_Name] = @Package_Name

END
GO

GRANT EXECUTE ON [Vulnerabilities_GetVulnerabilitiesForPackage] TO [ProGetUser_Role]
GO